
#include<sregf.h>
#include<sep_params.h>
#include "solver_basic.h"
#include "float_1d.h"
#include "cgstep.h"
#include "mat_mult.h"
#include "hypercube_mask.h"
#include "filt_1d.h"
#include "helicon.h"
#include "diagonal_wt.h"
#include "polydiv.h"
#include "i_op.h"
#include <iostream>

void mat_mult_test();
void rms_interval();

main(int argc, char **argv){

  sep_params pars=sep_params(argc,argv);
  
  
  //mat_mult_test();
  rms_interval();

}
void mat_mult_test(){
  float *a=new float[9];
  a[0]=1; a[1]=2; a[2]=3;
  a[3]=3; a[4]=1; a[5]=2;
  a[6]=2; a[7]=2; a[8]=2;
  
  float_1d *dat=new float_1d(3);
  dat->vals[0]=29; dat->vals[1]=18; dat->vals[2]=25;
  
  matmult_float_op *mat=new matmult_float_op(3,3,a);
  cgstep *st=new cgstep();
  lin_solver_basic *solv=new lin_solver_basic(st);
  solv->add_equation(dat,mat);
  float_1d *mod=(float_1d*) solv->solve(3);
  
  std::cout  << "model should be 1 6 5 "<< mod->vals[0]<<" "<<mod->vals[1]<< " "<<mod->vals[2]<<std::endl;
  
  
  delete st;
  delete solv;
  delete mat;
  delete [] a;
  delete dat;
}
void rms_interval(){

  sregf *rfile=new sregf("rms");
  sregf *wfile=new sregf("wt");
  
  
  hypercube_float *rms=new hypercube_float(rfile);
  rfile->read_all("rms",rms);
  
  hypercube_float *wt=new hypercube_float(wfile);
  wfile->read_all("wt",wt);
  
  deriv_filt *dfilt=new deriv_filt((int)rms->get_n123());
  deriv2_filt *dfilt2=new deriv2_filt((int)rms->get_n123());
  for(long long i=0; i < wt->get_n123(); i++) wt->vals[i]=wt->vals[i]/(1.+(float)i);
  diagonal_wt_float *wop=new diagonal_wt_float(rms,wt);
  /*
  if(!wop->dot_test(true)){
    fprintf(stderr,"WEIGHT FAILED\n");
    assert(1==2);
  }
  */
  helicon_float *deriv=new helicon_float(rms,dfilt2);
  /*
    if(!deriv->dot_test(true)){
    fprintf(stderr,"DERIV FAILED\n");
    assert(1==2);
  }
  */
  polydiv_float *causint= new polydiv_float(rms,dfilt);
  /*
    if(!causint->dot_test(true)){
    fprintf(stderr,"POLYDIV FAILED\n");
    assert(1==2);
  }
  */
  polydiv_float *causint2= new polydiv_float(rms,dfilt);
  /*
    if(!causint->dot_test(true)){
    fprintf(stderr,"POLYDIV FAILED\n");
    assert(1==2);
  }
  */
    i_op *iop = new i_op(rms,rms);
    /*
    if(!causint->dot_test(true)){
    fprintf(stderr,"POLYDIV FAILED\n");
    assert(1==2);
  }
  */
  std::vector<long long> map; map.push_back(0);
  hypercube_mask_pts *msk=new hypercube_mask_pts(rms,map);
 for(int i=0; i< (int) rms->get_n123(); i++) rms->vals[i]=rms->vals[i]*rms->vals[i]*(i+1);
 hypercube_float *mod0=(hypercube_float*)rms->clone_vec();
 for(int i=1; i<(int) rms->get_n123();i++) mod0->vals[i]=0.;
 
  float eps=1.;
  cgstep *st=new cgstep();

  lin_solver_basic *solv=new lin_solver_basic(st,causint2);
  solv->add_p0(mod0);
  solv->add_mask(msk);
 // solv->add_equation(rms,causint);
  solv->add_equation(rms,causint,wop);
  //solv->add_equation(deriv,eps);
  //solv->add_equation(iop,eps);
  hypercube_float *mod=(hypercube_float*) solv->solve(20);
  
  for(int i=0; i < (int) mod->get_n123(); i++)
    if(mod->vals[i] >0.) mod->vals[i]=sqrtf(mod->vals[i]);
    else mod->vals[i]=0.;
  
  rfile->write_description("interval");
  rfile->write_all("interval",mod);
  
  delete wt;
  delete dfilt2;
  delete iop;
  delete mod0;
  delete st; 
  delete rms; 
  delete mod; 
  delete msk;
  delete rfile; delete wfile; delete dfilt;
  delete causint; delete deriv;
}
