#include "acoustic_model_2d.h" 
#include "seplib.h"
 extern "C" {
   void   advance_it_(int *nz, int *nx, float *dz, float *dx, float *dt, 
     float *pm, float *p, float *pp, float *dvv);
        void   advance_it_h_(int *nz, int *nx, float *dz, float *dx, float *dt, 
     float *pm, float *p, float *pp, float *dvv);
        void   advance_it_dens_(int *nz, int *nx, float *dz, float *dx, float *dt, 
     float *pm, float *p, float *pp, float *dvv,float *od);
     void advance_it_nt(int nb,int *b_1,int *b_2,int *e_1,int *e_2,
       int nt, int nz,int nx,float *ax,float *az,float a0,float *dvv, float *pold_new,
         float *pcur);

 } 
acoustic_model_2d::acoustic_model_2d(){init_a_m_2d();}

void acoustic_model_2d::propogate_shot(float tm,bool insertit){

  float tabs=fabs(tm);
float near;
float delta;
  int nsteps=(int)(tabs/dt+.5);
  if(fabs(dt*nsteps-tabs) >dt/10.) seperr("steps must be multiple of dt");
  int ix;
  
  
    pm=p1; p=p2; pp=p3;

 
delta=tm/nsteps;
  for(int it=0; it < nsteps; it++){
     ix=it%3;
  
  //if(ix==0){ 
 
    pm=p1; p=p2; pp=p3;

  if(dens==0)
   advance_it_h_(&nz,&nx,&dz,&dx,&dt,pm,p,pp,dvv);
   else {
     advance_it_dens_(&nz,&nx,&dz,&dx,&dt,pm,p,pp,dvv,dens);
   
   }
   do_bound(pm,p,pp);
   time+=tm/nsteps;
  if(insertit) insert->insert_data(nz,oz,dz,nx,ox,dx,pp,time);

 near=floor(time/.05+.5)*.05;

    if((time > near && time+delta < near) || (time < near  && time+delta > near)){
    wr+=1;
     fprintf(stderr,"PROPAGATING TIME %f %d \n",time,nx);
//   srite("junk.H",pp,nx*nz*4);

    }
  
 

    for(int i=0; i < nx*nz; i++){
      pm[i]=p[i]; p[i]=pp[i];
    }

}

}
  void acoustic_model_2d::init_vel(int b2,int e2){
      nx=e2-b2+1;
      bx=b2;ex=e2;
      nz=vel->get_axis(1).n;
      int nxm=vel->get_axis(2).n;
      int i=0;
      dvv=new float[nx*nz];
     if(vel->has_dens()){
        dens=new float[nx*nz];
          for(int ix=0; ix < nx; ix++){
          int ixu=MAX(0,MIN(nxm-1,ix+b2));
        for(int iz=0; iz < nz; iz++,i++){
        dvv[i]=vel->fld->vals[iz+(ixu)*nz]*vel->fld->vals[iz+(ixu)*nz]*
          vel->dens->vals[iz+(ixu)*nz];
          dens[i]=1./vel->dens->vals[iz+(ixu)*nz];
         }
       }
      }
      else{
     
      i=0;
      for(int ix=0; ix < nx; ix++){
        int ixu=MAX(0,MIN(nxm-1,ix+b2));
        for(int iz=0; iz < nz; iz++,i++){
          dvv[i]=vel->fld->vals[iz+(ixu)*nz]*vel->fld->vals[iz+(ixu)*nz];
         }
       }
      }
     dx=vel->get_axis(2).d;
     dz=vel->get_axis(1).d;
     ox=vel->get_axis(2).o+b2*vel->get_axis(2).d;
     oz=vel->get_axis(1).o;
 //    srite("junk.H",dvv,nx*nz*4);
  //fprintf(stderr,"NX %d %d \n",nx,nz);
  //srite("junk.H",dens,nx*nz*4);
    }
 void acoustic_model_2d::one_step(float *dvv, 
    float *pm,float *p, float *pp, int nx, float dx,
       int nz, float dz, float dt){
       
        float a1x,a1z,a2x,a2z,a3x,a3z,a4x,a4z,a5x,a5z,a0;
        
        a1x=3.333333333*dt*dt/(2*dx*dx);
        a1z=3.333333333*dt*dt/(2*dz*dz);

        a2x=-.4761904762*dt*dt/(2*dx*dx);
        a2z=-.4761904762*dt*dt/(2*dz*dz);

        a3x=.0793650794*dt*dt/(2*dx*dx);
        a3z=.0793650794*dt*dt/(2*dz*dz);

        a4x=-.0099206349*dt*dt/(2*dx*dx);
        a4z=-.0099206349*dt*dt/(2*dz*dz);

        a5x=.0006349206*dt*dt/(2*dx*dx);
        a5z=.0006349206*dt*dt/(2*dz*dz);

        a0=a5x+a5z+a4x+a4z+a3x+a3z+a2x+a2z+a1x+a1z;
        a0=-2.*a0;
        register int X_1=nz, X_2=nz*2, X_3=nz*3,X_4=nz*4, X_5=nz*5;
        register int Z_1=1, Z_2=2, Z_3=3, Z_4=4, Z_5=5;
      //  fprintf(stderr,"WHAT THE %d %d \n",nz,nx);
        
        float z1,x1;
        z1=dt*dt/2./dz/dz;
        x1=dt*dt/2./dx/dx;
        float xz=-(z1*2+x1*2);
     int nc=0;
     if(1==1){
       for(int ix=5; ix < nx-5; ix++){
         for(int iz=5; iz< nz-5; iz++){
           pp[iz+nz*ix]=-pm[iz+nz*ix]+2.0*p[iz+nz*ix]+dvv[iz+nz*ix]*(
             p[iz+nz*ix]*a0+
             a1x*(p[iz+ (ix+1)*nz]+p[iz+(ix-1)*nz])+
             a2x*(p[iz+ (ix+2)*nz]+p[iz+(ix-2)*nz])+
             a3x*(p[iz+ (ix+3)*nz]+p[iz+(ix-3)*nz])+
             a4x*(p[iz+ (ix+4)*nz]+p[iz+(ix-4)*nz])+
             a5x*(p[iz+ (ix+5)*nz]+p[iz+(ix-5)*nz])+
             a1z*(p[iz+1+ (ix)*nz]+p[iz-1+(ix)*nz])+
             a2z*(p[iz+2+ (ix)*nz]+p[iz-2+(ix)*nz])+
             a3z*(p[iz+3+ (ix)*nz]+p[iz-3+(ix)*nz])+
             a4z*(p[iz+4+ (ix)*nz]+p[iz-4+(ix)*nz])+
             a5z*(p[iz+5+ (ix)*nz]+p[iz-5+(ix)*nz]));
             nc+=1;
          }    
        } 
        
      }
      else if(1==2){
        for(int ix=1; ix < nx-1; ix++){
         for(int iz=1; iz< nz-1; iz++){
        pp[iz+nz*ix]=-pm[iz+nz*ix]+2.0*p[iz+nz*ix]+dvv[iz+nz*ix]*(
             xz*p[iz+nz*ix]+(
               z1*p[iz+1+ix*nz]+z1*p[iz-1+ix*nz]+x1*p[iz+(ix-1)*nz]+x1*p[iz+(ix+1)*nz]));
    //  if(ix==920 && iz==2) fprintf(stderr,"XX 1 %g %g %g  %g \n",
     //   (double)p[iz+ix*nz],(double)pp[iz+nz*ix],(double)p[iz-1+ix*nz],(double)p[iz+1+ix*nz]);
      }}
      }
      else{
        int nsz=(nx-10)*(nz-10);
        register float *pp_,*pm_,*p_,*dvv_;
        pp_=&pp[5+nz*5]; pm_=&pm[5+nz*5]; dvv_=&dvv[5+nz*5]; p_=&p[5+nz+5];
        int iz=5;
        int ix=5;
        for(int i=0 ; i < nsz; i++){
           *pp_=-
           *pm_+2.*
                *p_+
                *dvv_*(
             *p_*a0+
             a1x*(*(p+X_1)+*(p-X_1))+
             a2x*(*(p+X_2)+*(p-X_2))+
             a3x*(*(p+X_3)+*(p-X_3))+
             a4x*(*(p+X_4)+*(p-X_4))+            
             a5x*(*(p+X_5)+*(p-X_5))+    
             a1z*(*(p+Z_1)+*(p-Z_1))+
             a2z*(*(p+Z_2)+*(p-Z_2))+
             a3z*(*(p+Z_3)+*(p-Z_3))+
             a4z*(*(p+Z_4)+*(p-Z_4))+            
             a5z*(*(p+Z_5)+*(p-Z_5)));
             iz++;
             if(iz==nz-6){
               iz=5;
               ix+=1;
               pp_=&pp[5+nz*ix]; pm_=&pm[5+nz*ix]; dvv_=&dvv[5+nz*ix]; p_=&p[5+nz*ix];
             }
             else{
                 pp_++; pm_++; dvv_++; p_++;
             }
                     nc+=1;

        }
      
       }
     //  fprintf(stderr,"CHECME %d \n",nc);

    }       
