#ifndef ABCD_1
#define ABCD_1 1
#include "vel_rtm_2d.h"
#include "wavefield_insert.h"
#include <math.h>
class acoustic_model_2d{
  public:
    acoustic_model_2d();
  
    ~acoustic_model_2d(){ delete_acoustic_model();}
    
    void set_check_vel(vel_rtm_2d *v,float data_dt){
      float vmin=v->min_vel();
      float vmax=v->max_vel();
      vel=v;
      float dmin=v->get_min_samp();
      float d=.5*dmin/vmax;
      dt=data_dt/ceilf(data_dt/d);
  
    
    }
 
    void init_modeling(int b2, int e2){
      delete_acoustic_model();
      init_vel(b2,e2);
      p1= new float [nz*nx];
      p2= new float [nz*nx];
      p3 =new float [nz*nx];
      time=0.;
      wr=0;
    }
    void set_initial_time(float tm){ time=tm;}
    
    void reverse_prop_fields(){
       for(int i=0; i < nz*nx; i++){
          float j=p1[i]; p1[i]=p2[i]; p2[i]=j;
       }
    }
    void one_step(float *dvv, 
     float *p_,float *pm_,float *pp_, int nx, float dx,
       int nz, float dz, float dt);
       
     
    void init_vel(int b2,int e2);
   
    void set_source_function(wavefield_insert *ins){ 
      insert=ins;
      set_check_vel(vel,insert->dsamp);
      }
    void propogate_shot(float tm, bool insertit=true);
    void propogate_shot_new(float tm, bool insertit=true);

    void delete_acoustic_model(){
       
       if(p1!=0) delete []p1;
       if(p2!=0) delete [] p2;
       if(p3!=0 ) delete [] p3;
       clean_vel();
    }
    void clean_vel(){
     if(dvv!=0){
         delete [] dvv;
     }
     dvv=0;
     if(dens!=0) {
        delete [] dens;
     }
     dens=0;
    
    }
    virtual void do_bound(float *pm, float *p, float *pp){};
    void init_a_m_2d(){
       pp=0; pm=0; p=0;
       p1=0; p2=0; p3=0;
       dvv=0; dens=0;
    }
  
    wavefield_insert *insert;
    float *p1,*p2,*p3;
    float *pp,*pm,*p;
    vel_rtm_2d *vel;
    float *dvv;
    float *dens;
    int nz,nx;
    int bx,ex;
    float dt;
    float dx,dz;
    float oz,ox;
    float time;
    int wr;

    
    
};
#endif
