#include "acoustic_model_2d_damp.h"
#include <math.h>

acoustic_model_2d_damp::acoustic_model_2d_damp(vel_rtm_2d *vv,int b2, int e2, bool bndt,
 bool bndb, bool bndl, bool bndr){

  vel=vv;
  bt=bndt;
  bl=bndl;
  br=bndr;
  bb=bndb;
  fprintf(stderr,"BB \n");
  init_modeling(b2,e2);
  fprintf(stderr,"XX \n");
  construct_damp(20);
  
}
void acoustic_model_2d_damp::construct_damp(int nsz){

  ndamp=nsz;
  damp=new float [ndamp];
  float a0=.3/float(ndamp);
  for(int i=0; i < ndamp;i++){
     damp[i]=exp(-powf(a0*((float)(ndamp-i)),2.));
  }
   

}

void acoustic_model_2d_damp::do_bound(float *pm, float *p, float *pp){

  if(this->bt>0){
    for(int ix=0; ix < nx; ix++){
      for(int iz=0; iz < ndamp; iz++){
        pm[iz+ix*nz]*=damp[iz];
        p[iz+ix*nz]*=damp[iz];
        pp[iz+ix*nz]*=damp[iz];
      }
    }
 }
 if(this->bb>0){
    for(int ix=0; ix < nx; ix++){
      for(int iz=0; iz < ndamp; iz++){
        pm[(nz-iz-1)+ix*nz]*=damp[iz];
        p[(nz-iz-1)+ix*nz]*=damp[iz];
        pp[(nz-iz-1)+ix*nz]*=damp[iz];
      }
    }
  }
 if(this->bl>0){
    for(int ix=0; ix < ndamp; ix++){
      for(int iz=0; iz < nz; iz++){
    
        pm[iz+ix*nz]*=damp[ix];
        p[iz+ix*nz]*=damp[ix];
        pp[iz+ix*nz]*=damp[ix];
      }
    }
   }
 if(this->br>0){
      for(int ix=0; ix < ndamp; ix++){
      for(int iz=0; iz < nz; iz++){
        pm[iz+(nx-ix-1)*nz]*=damp[ix];
        p[iz+(nx-ix-1)*nz]*=damp[ix];
        pp[iz+(nx-ix-1)*nz]*=damp[ix];
      }
    }
 }


}

