 
 subroutine advance_it(nz,nx,dz,dx,dt,pm,p,pp,dvv);
  real :: pm(nz,nx),p(nz,nx),pp(nz,nx),dvv(nz,nx)
  integer :: i1,i2,it,i,nx,nz
  logical :: do_for
  real  :: q,a1x,a1z,a2x,a2z,a3x,a3z,a4x,a4z,a5x,a5z,a0,x
  real :: dtx,dtz
  real deriv1,deriv2;
  
  dtx=dt*dt/dx/dx
  dtz=dt*dt/dz/dz
  
  a1x=3.333333333*dt*dt/(2*dx*dx);
        a1z=3.333333333*dt*dt/(2*dz*dz);

        a2x=-.4761904762*dt*dt/(2*dx*dx);
        a2z=-.4761904762*dt*dt/(2*dz*dz);

        a3x=.0793650794*dt*dt/(2*dx*dx);
        a3z=.0793650794*dt*dt/(2*dz*dz);

        a4x=-.0099206349*dt*dt/(2*dx*dx);
        a4z=-.0099206349*dt*dt/(2*dz*dz);

        a5x=.0006349206*dt*dt/(2*dx*dx);
        a5z=.0006349206*dt*dt/(2*dz*dz);

    
        z_d=0; x_d=0; offset=0
        
        a0=-2.*a0;


!$OMP PARALLEL DO default(shared) private(x,i1,i2)
  do i2=6,nx-5
    do i1=6,nz-5
       x=dvv(i1,i2)*(&
             p(i1,i2)*a0+&
             a1x*(p(i1,i2+1)+p(i1,i2-1))+&
             a2x*(p(i1,i2+2)+p(i1,i2-2))+&
             a3x*(p(i1,i2+3)+p(i1,i2-3))+&
             a4x*(p(i1,i2+4)+p(i1,i2-4))+&
             a5x*(p(i1,i2+5)+p(i1,i2-5))+&
             a1z*(p(i1+1,i2)+p(i1-1,i2))+&
             a2z*(p(i1+2,i2)+p(i1-2,i2))+&
             a3z*(p(i1+3,i2)+p(i1-3,i2))+&
             a4z*(p(i1+4,i2)+p(i1-4,i2))+&
             a5z*(p(i1+5,i2)+p(i1-5,i2)))
                    pp(i1,i2)=-pm(i1,i2)+2.0*p(i1,i2)+x

    end do
  end do
!$OMP END PARALLEL DO
end subroutine



 subroutine advance_it_h(nz,nx,dz,dx,dt,pm,p,pp,dvv)
  real :: pm(nz*nz),p(nz*nx),pp(nz*nx),dvv(nz*nx)
  integer :: i1,i2,it,i,nx,nz
  logical :: do_for
  real  :: q,a1x,a1z,a2x,a2z,a3x,a3z,a4x,a4z,a5x,a5z,a0,x
  real :: dtx,dtz
  real deriv1,deriv2;
  
  dtx=dt*dt/dx/dx
  dtz=dt*dt/dz/dz
  
  a1x=3.333333333*dt*dt/(2*dx*dx);
        a1z=3.333333333*dt*dt/(2*dz*dz);

        a2x=-.4761904762*dt*dt/(2*dx*dx);
        a2z=-.4761904762*dt*dt/(2*dz*dz);

        a3x=.0793650794*dt*dt/(2*dx*dx);
        a3z=.0793650794*dt*dt/(2*dz*dz);

        a4x=-.0099206349*dt*dt/(2*dx*dx);
        a4z=-.0099206349*dt*dt/(2*dz*dz);

        a5x=.0006349206*dt*dt/(2*dx*dx);
        a5z=.0006349206*dt*dt/(2*dz*dz);

    
        z_d=0; x_d=0; offset=0
        

    a0=a5x+a5z+a4x+a4z+a3x+a3z+a2x+a2z+a1x+a1z;
        a0=-2.*a0;
          j1=nz
  j2=nz*2
  j3=nz*3
  j4=nz*4
  j5=nz*5

  !$OMP PARALLEL DO default(shared) private(i1,x)
    do i1=j5+5,nz*nx-j5-5
       x=dvv(i1)*(&
             p(i1)*a0+&
             a1x*(p(i1+j1)+p(i1-j1))+&
             a2x*(p(i1+j2)+p(i1-j2))+&
             a3x*(p(i1+j3)+p(i1-j3))+&
             a4x*(p(i1+j4)+p(i1-j4))+&
             a5x*(p(i1+j5)+p(i1-j5))+&
             a1z*(p(i1+1)+p(i1-1))+&
             a2z*(p(i1+2)+p(i1-2))+&
             a3z*(p(i1+3)+p(i1-3))+&
             a4z*(p(i1+4)+p(i1-4))+&
             a5z*(p(i1+5)+p(i1-5)))
             pp(i1)=-pm(i1)+2.0*p(i1)+x

  end do
  !$OMP END PARALLEL DO
  
  
  
end subroutine







 
