#include "data_rtm_2d.h"
#include <math.h>

data_rtm_2d::data_rtm_2d(char *tg){
   tag=tg;
   dfile=new sregf(tg);
   //Should do sanity checks here

  axis a=dfile->get_axis(1);
  max_time=a.o+a.d*(a.n-1);
  max_time=max_time;
  //max_time=.2;
  dt=a.d;
  nt=a.n;
   rec_locs=0; data=0;
   dsamp=dt;
rec_depth=0.;
}


void data_rtm_2d::load_shot(){

 clear_shot_data();
 //For now this all assumes a regular cube
 axis a1=dfile->get_axis(1);
 axis a2=dfile->get_axis(2);
 axis a3=dfile->get_axis(3);
 rec_locs=new float[a2.n];
 data=new float[a1.n*a2.n];
 nrec=a2.n;
 for(int i2=0; i2 < a2.n; i2++){
    rec_locs[i2]=a2.o+a2.d*(i2-1)+a3.o+a3.d*shot_num; //Assumes offset source position
 } 
 sreed(tag,data,a1.n*a2.n*4);
//fprintf(stderr,"LOADINING %f \n",data[1000]);
}

void data_rtm_2d::insert_data(int nz, float oz, float dz, int nx, float ox, float dx,
       float *fld, float tm){
       
 
float loc_z=(rec_depth-oz)/dz;
 axis tax=dfile->get_axis(1);
 float fsamp=(tm-tax.o)/tax.d;
 int nt=tax.n;
 if(fsamp<0 || fsamp >= tax.n-1) return;
  int it=(int) fsamp;
 float f=fsamp-it;
for(int i2=0; i2 < nrec;i2++){
  float loc_x=(rec_locs[i2]-ox)/dx;
 

 //Can do better than linear interpolation
 float val=(1.-f)*data[it+i2*nt]+f*data[nt*i2+it+1];
//if(val > .0001) fprintf(stderr,"PUTTING  %f %f %f %f %f %d %d \n",loc_x,loc_z,rec_locs[i2],ox,dx,nx,nrec);
 for(int ix=MAX(0.,MIN(nx*1.,(loc_x-3))); ix <MAX(0,MIN(nx*1.,loc_x+3)); ix++){
    float xn=loc_x-ix;
    for(int iz=MAX(0.,MIN(nz*1.,loc_z-3)); iz < MAX(0.,MIN(nz*1.,loc_z+3)); iz++){
      float zn=loc_z-iz;
      fld[iz+ix*nz]-=expf(-zn*zn-xn*xn)*val;
    }
  }   
       
 }
 
 }
 
 