#include<sep_params.h>
#include<sregf.h>
#include <seplib.h>
#include <vel_rtm_2d.h>
#include "model_it_roll.h"
#include "model_it.h"
#include "wavelet_rtm.h"
#include "acoustic_model_2d_damp.h"
#include "acoustic_model_2d_rand.h"

 main(int argc, char **argv){

   sep_params pars=sep_params(argc,argv);
   
   
   wavelet_rtm wavelet=wavelet_rtm("wavelet");
   
   vel_rtm_2d vel=vel_rtm_2d("velocity");
   
   //,"density"); 
    
   float range_x=pars.get_float("range_x",8.);
   axis v2=vel.fld->get_axis(2);
   axis v1=vel.fld->get_axis(1);
   model_roll model=model_roll("out",v1,v2,&pars,range_x);
   
   for(int ishots=0; ishots < model.nshots(); ishots++){
     float sz,sx;    
     int b2,e2;
     model.set_shot(ishots);
     model.get_sx_sz(&sx,&sz,&b2,&e2);
     fprintf(stderr,"WORKING ON %d of %d %f %f %d %d \n",ishots,model.nshots(),sx,sz,b2,e2);
     wavelet.set_source_loc(sx,sz);
  acoustic_model_2d_damp shot_mod=acoustic_model_2d_damp(&vel,b2,e2); 

   shot_mod.set_source_function(&wavelet);

     shot_mod.set_initial_time(0.);

     for(int it=0; it < model.nt; it++){
        shot_mod.propogate_shot(model.dt);

        model.set_data(&shot_mod,it);     
     }
     model.finish_shot();

   }
   
   return 0;
 }
       






