#include "model_it_roll.h"
 
model_roll::model_roll(char *tg,axis a1,axis a2,param_func *pars,float rang){

  tag=tg;
  ax2=a2;
  ax1=a1;
  range_x=rang;

  ooff=pars->get_float("ooff");
  doff=pars->get_float("doff");
  noff=pars->get_int("noff");

  osrc=pars->get_float("osrc");
  dsrc=pars->get_float("dsrc");
  nsrc=pars->get_int("nsrc");
  
  nt=pars->get_int("nt");
  dt=pars->get_float("dt");
  
  float z=pars->get_float("sz");
  
  sx=new float[nsrc];
  sz=new float[nsrc];
  nshot=nsrc;
  for(int i=0; i < nsrc;i++){
    sx[i]=osrc+dsrc*i;
    sz[i]=z;
  }
  write_description();

}

void model_roll::write_description(){

int iax; 
char lab[1024];
float t0=0.;
iax=1;strcpy(lab,"time"); sep_put_data_axis_par(tag,&iax,&nt,&t0,&dt,lab);
iax=2;strcpy(lab,"offset"); sep_put_data_axis_par(tag,&iax,&noff,&ooff,&doff,lab);
iax=3;strcpy(lab,"src"); sep_put_data_axis_par(tag,&iax,&nsrc,&osrc,&dsrc,lab);

}
 
void model_roll::set_shot(int is){
  ishot=is;
    set_range();

  if(gather!=0) delete [] gather;  gather=new float [noff*nt];
  if(xpos!=0) delete [] xpos; xpos=new int[noff];
  if(zpos!=0) delete [] zpos; zpos=new int[noff];
  nrecs=noff;
  for(int i=0; i < nrecs; i++){
    zpos[i]=(sz[ishot]-ax1.o)/ax1.d+.5;
    xpos[i]=(sx[ishot]+ooff+doff*i-ax2.o)/ax2.d+.5;
  //  fprintf(stderr,"CONSTRUCTION %d %d %d - %d %d \n",i,xpos[i],zpos[i],bx,ex);  
    if(xpos[i] < bx || xpos[i] >ex) xpos[i]=-1;
    else xpos[i]-=bx;

  }
}