#include "wavelet_rtm.h"
#include<math.h>
wavelet_rtm::wavelet_rtm(char *tag){
   sregf wfile=sregf(tag);
   wavelet=new hypercube_float(&wfile);
   wfile.read_all(tag,wavelet);
   dsamp=wfile.get_axis(1).d;
}
void wavelet_rtm::insert_data(int nz, float oz, float dz, int nx, float ox, float dx,
       float *fld, float tm){
       
 float loc_x=(sx-ox)/dx;
 float loc_z=(sz-oz)/dz;
 //loc_z=50;
 int xb=MIN(nx-1,MAX(0,floor(loc_x)-3));
 int xe=MAX(0,MIN(nx-1,ceilf(loc_x)+3));
 int zb=MIN(nz-1,MAX(0,floor(loc_z)-3));
 int ze=MAX(0,MIN(nz-1,ceilf(loc_z)+3));

 //Can do better than linear interpolation
 axis tax=wavelet->get_axis(1);
 float fsamp=(tm-tax.o)/tax.d;
 
 if(fsamp<0 || fsamp >= tax.n-1) {
    return;
   }
 int it=(int) fsamp;
 float f=fsamp-it;
 float val=(1.-f)*wavelet->vals[it]+f*wavelet->vals[it+1];
 
  //fprintf(stderr,"TIME TO INSERT %f %f %f \n",loc_x,loc_z,val);
// fprintf(stderr,"CHECK VAL %g %g %f %f %f \n",(double)fld[zb+xb*nz],(double)val,tm,loc_z,loc_x);


 for(int ix=xb; ix < xe; ix++){
    float xn=loc_x-ix;
    for(int iz=zb; iz < ze; iz++){
      float zn=loc_z-iz;
      fld[iz+ix*nz]-=expf(-zn*zn-xn*xn)*val;

    }
  }
 
          
       
}